Program serial;

uses crt,cursor;

const

bps300 =384;
bps1200=96;
bps2400=48;
bps4800=24;
bps9600=12;
bps14400=8;
bps19200=6;
bps28800=4;
bps38400=3;
bps57600=2;
bps115200=1;

pNoneParity=$00;
pEvenParity=$18;
pOddParity=$08;

s1StopBit=$00;
s2StopBit=$04;

d5DataBit=$00;
d6DataBit=$01;
d7DataBit=$02;
d8DataBit=$03;

COM1=$3f8;
COM2=$2f8;

THR=$00;
RBR=$00;
DLL=$00;
DLH=$01;
IER=$01;
IIR=$02;
LCR=$03;
MCR=$04;
LSR=$05;
MSR=$06;
SCR=$07;

var
   base :word;
   c    :char;
   ECHO :boolean;
   comport :word;
   a,b,i   :integer;

procedure SetSpeed(Speed:word); {sebessg beallitasa}
assembler;
asm
   mov dx,base
   add dx,LCR
   in  al,dx
   or  al,10000000b
   out dx,al
   mov bl,al
   sub dx,LCR
   mov ax,Speed
   out dx,ax
   add dx,LCR
   mov al,bl
   and al,01111111b
   out dx,al
end;

procedure InitSerialPort(COM:word; Defaults:byte); {port beallitas}
assembler;
asm
   mov dx,COM
   mov Base,dx
   in  al,dx
   mov al,Defaults
   and al,01111111b
   add dx,LCR
   out dx,al
   inc dx
   in  al,dx
   and al,$01
   or  al,$0a
   out dx,al
   mov dx,Base
   in  al,dx
   add dx,MSR
   in  al,dx
   dec dx
   in  al,dx
   sub dx,3
   in  al,dx
end;

procedure SendChar(C:char);
assembler;
asm
   mov dx,Base
   add dx,LSR
   @wait:
    in  al,dx
    and al,00100000b
    jz  @wait
    sub dx,5
    mov al,C
    out dx,al
end;

function ReceiveChar:char;
assembler;
asm
   mov dx,Base
   in  al,dx
end;

function DataReady:boolean;
assembler;
asm
   mov dx,Base
   add dx,LSR
   in  al,dx
   and al,00000001b
end;

BEGIN
  cursoroff;
  clrscr;
  textattr:=cyan;
  gotoxy(24,3);
  Writeln('Soros Kommunikacio DEMO program');
  gotoxy(33,4);
  writeln('Kilepes: ESC');
  gotoxy(10,6);
  Writeln('Adja meg a port szamat: ');
  textattr:=yellow;
  gotoxy(10,8);
  writeln('COM1 --> 1');
  gotoxy(10,9);
  writeln('COM2 --> 2');


  repeat
   c:=readkey;
   if (not((c='1') or (c='2') or (c=#27))) then
   begin
     textattr:=lightred;
     gotoxy(10,11);
     writeln('HIBAS GOMB');
   end;
   until ((c='1') or (c='2') or (c=#27));
   textattr:=yellow;

   if c=#27 then halt(1);

   if c='1' then
   begin
     comport:=COM1;
     gotoxy(10,11);
     writeln('A kivalasztott port: COM1');
   end;

   if c='2' then
   begin
     comport:=COM2;
     gotoxy(10,11);
     writeln('A kivlasztott port: COM2');
   end;

   if c=#27 then halt(1);

   InitSerialPort(comport,pNoneParity or s1StopBit or d8DataBit);
   SetSpeed(bps300);

   textattr:=cyan;
   gotoxy(10,13);
   writeln('Adja meg az zemmdot: ');
   textattr:=yellow;
   gotoxy(10,15);
   writeln('DEMO --> 1');
   gotoxy(10,16);
   writeln('Terminal --> 2');

   repeat
   c:=readkey;
   if (not((c='1') or (c='2') or (c=#27))) then
   begin
     textattr:=lightred;
     gotoxy(10,17);
     writeln('HIBAS GOMB');
   end;
   until ((c='1') or (c='2') or (c=#27));
   textattr:=yellow;

   if c='1' then
   begin
     clrscr;
     textattr:=cyan;
     gotoxy(36,4);
     writeln('DEMO mod');
     gotoxy(10,6);
     writeln('Uzemmod: ');
     textattr:=yellow;
     writeln('Csak oda -->1');
     gotoxy(10,9);
     writeln('Oda-Vissza -->2');


     repeat
     c:=readkey;
     if (not((c='1') or (c='2') or (c=#27))) then
     begin
       textattr:=lightred;
       gotoxy(10,11);
       writeln('HIBAS GOMB');
     end;
     until ((c='1') or (c='2') or (c=#27));
     textattr:=yellow;

     a:=50;
     repeat
     b:=1;
     for i:=1 to 8 do
     begin
       sendchar(char(b));
       delay(a);
       b:=b*2;
       if DataReady then a:=((integer(ReceiveChar)))+50;
       textattr:=lightred;
       gotoxy(26,13);
       Writeln('A kesleltetes erteke: ',a,'ms');
     end;
     b:=b div 2;
     if c='2' then
     begin
       for i:=1 to 8 do
       begin
         sendchar(char(b));
         delay(a);
         b:=b div 2;
         if dataReady then a:=((integer(receiveChar)))+50;
         gotoxy(26,13);
         writeln('A kesleltetes erteke: ',a,'ms');
       end;
     end;
     until keypressed;
     sendchar(#0);
     c:='3';
     end;

   if c='2' then
   begin
     echo:=true;
     clrscr;
     gotoxy(34,5);
     writeln('Terminal mod');
     writeln;
     repeat
      if keypressed then
      begin
        c:=readkey;
        SendChar(c);
        if ECHO then
        begin
          textattr:=lightred;
          write(c);
          textattr:=yellow;
        end;
      end;
      if DataReady then write(ReceiveChar);
      until c=#27;
      end;
     end.
